oracle.kv

## Class ConsistencyException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - java.lang.RuntimeException
      - - oracle.kv.FaultException
        - - oracle.kv.ConsistencyException

- All Implemented Interfaces:
    Serializable

      public class ConsistencyException
      extends FaultException

  Thrown when a single or multiple-operation transaction fails because the specified `Consistency` could not be met, within the allowed timeout period.

  The likelihood of this exception being thrown depends on the specified `Consistency` and the general health of the KVStore system. The default consistency policy (specified by `KVStoreConfig.getConsistency()`) is `Consistency.NONE_REQUIRED`. With `Consistency.NONE_REQUIRED` (the default), `Consistency.NONE_REQUIRED_NO_MASTER`, or `Consistency.ABSOLUTE`, this exception will never be thrown.

  If the client overrides the default and specifies a `Consistency.Time` or `Consistency.Version` setting, then this exception will be thrown when the specified consistency requirement cannot be satisfied within the timeout period associated with the consistency setting. If this exception is encountered frequently, it indicates that the consistency policy requirements are too strict and cannot be met routinely given the load being placed on the system and the hardware resources that are available to service the load.

  Depending on the nature of the application, when this exception is thrown the client may wish to

  - retry the read operation,
  - fall back to using a larger timeout or a less restrictive consistency setting (for example, `Consistency.NONE_REQUIRED`), and resume using the original consistency setting at a later time, or
  - give up and report an error at a higher level.
  See Also:
    Serialized Form

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Consistency` | `getConsistency()` Returns the consistency policy that could not be satisfied.

    - ### Methods inherited from class oracle.kv.FaultException

      `getFaultClassName, getRemoteStackTrace, toString, wasLoggedRemotely`

    - ### Methods inherited from class java.lang.Throwable

      `fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### getConsistency

          public Consistency getConsistency()

      Returns the consistency policy that could not be satisfied.

Copyright (c) 2011, 2014 Oracle and/or its affiliates. All rights reserved.